searchNodes=[{"doc":"Provides a modular approach for using beam-telemetry packages. Quick Start Before running Elixir.CozyTelemetry , you must provide some modules. For example: defmodule MyApp.Cache do use CozyTelemetry.Metrics use CozyTelemetry.Measurements @impl CozyTelemetry.Metrics def metrics ( meta ) do [ summary ( &quot;cache.duration&quot; , unit : { :native , :second } , tags : [ :type , :key ] ) ] end @impl CozyTelemetry.Measurements def periodic_measurements ( meta ) do [ { __MODULE__ , :dispatch_stats , [ ] } ] end end Then, set some base configuration within config/config.exs : config :my_app , CozyTelemetry , meta : [ ] , metrics : [ MyApp.Cache ] , measurements : [ MyApp.Cache ] , reporter : { :console , [ ] } , poller : [ period : 10_000 ] Use the application configuration you've already set and include Elixir.CozyTelemetry in the list of supervised children: # lib/my_app/application.ex def start ( _type , _args ) do cozy_telemetry_config = Application . fetch_env! ( :my_app , CozyTelemetry ) children = [ { CozyTelemetry.Reporter , cozy_telemetry_config } , { CozyTelemetry.Poller , cozy_telemetry_config } , # ... ] Supervisor . start_link ( children , strategy : :one_for_one , name : MyApp.Supervisor ) end about option :meta The value of option :meta is a keyword list, which will be passed as the argument of callback metrics/1 of CozyTelemetry.Metrics . See CozyTelemetry.Metrics . about option :metrics The value of option :metrics is a list of metrics modules. See CozyTelemetry.Metrics . about option :optional_metrics Same as option :metrics , but ignore errors when the given metrics module is missing. about option :measurements The value of option :measurements is a list of measurements modules. See CozyTelemetry.Measurements . about option :optional_measurements Same as option :measurements , but ignore errors when the given measurements module is missing. See CozyTelemetry.Measurements . When using :cozy_telemetry as a direct dependency, this option is unnecessary. But, when building a new package on :cozy_telemetry , this option is useful for some case, such as auto loading measurements modules. about option :reporter The value of option :reporter specifies the reporter and its options, which is in format of {type, reporter_opts} : available values of type are :console , :statsd , prometheus . available values of reporter_opts can be found in corresponding underlying modules: Telemetry.Metrics.ConsoleReporter TelemetryMetricsStatsd TelemetryMetricsPrometheus about option :poller The value of option :poller is the options of :telemetry_poller.start_link/1 .","ref":"CozyTelemetry.html","title":"CozyTelemetry","type":"module"},{"doc":"A behaviour for declaring periodic measurements. Any module that wants to run periodic measurements should implement this behaviour. defmodule MyApp.Cache do use CozyTelemetry.Measurements @impl CozyTelemetry.Measurements def periodic_measurements ( meta ) do [ { __MODULE__ , :dispatch_stats , [ ] } ] end end Then, the declared measurements in above module can be loaded with following configuration: config :my_app , CozyTelemetry , meta : [ ] , metrics : [ ] , measurements : [ MyApp.Cache ] , # ...","ref":"CozyTelemetry.Measurements.html","title":"CozyTelemetry.Measurements","type":"behaviour"},{"doc":"Loads the measurements from given module.","ref":"CozyTelemetry.Measurements.html#load_measurements_from_module/2","title":"CozyTelemetry.Measurements.load_measurements_from_module/2","type":"function"},{"doc":"Same as load_measurements_from_module/2 but raises if the module cannot be loaded.","ref":"CozyTelemetry.Measurements.html#load_measurements_from_module!/2","title":"CozyTelemetry.Measurements.load_measurements_from_module!/2","type":"function"},{"doc":"","ref":"CozyTelemetry.Measurements.html#c:periodic_measurements/1","title":"CozyTelemetry.Measurements.periodic_measurements/1","type":"callback"},{"doc":"","ref":"CozyTelemetry.Measurements.html#t:meta/0","title":"CozyTelemetry.Measurements.meta/0","type":"type"},{"doc":"A behaviour for declaring metrics. Any module that wants to exposing metrics should implement this behaviour. defmodule MyApp.Cache do use CozyTelemetry.Metrics @impl CozyTelemetry.Metrics def metrics ( meta ) do [ summary ( &quot;cache.duration&quot; , unit : { :native , :second } , tags : [ :type , :key ] ) ] end end Then, the declared metrics in above module can be loaded with following configuration: config :my_app , CozyTelemetry , meta : [ ] , metrics : [ MyApp.Cache ] , # ...","ref":"CozyTelemetry.Metrics.html","title":"CozyTelemetry.Metrics","type":"behaviour"},{"doc":"Loads the metrics from given module.","ref":"CozyTelemetry.Metrics.html#load_metrics_from_module/2","title":"CozyTelemetry.Metrics.load_metrics_from_module/2","type":"function"},{"doc":"Same as load_metrics_from_module/2 but raises if the module cannot be loaded.","ref":"CozyTelemetry.Metrics.html#load_metrics_from_module!/2","title":"CozyTelemetry.Metrics.load_metrics_from_module!/2","type":"function"},{"doc":"","ref":"CozyTelemetry.Metrics.html#c:metrics/1","title":"CozyTelemetry.Metrics.metrics/1","type":"callback"},{"doc":"","ref":"CozyTelemetry.Metrics.html#t:meta/0","title":"CozyTelemetry.Metrics.meta/0","type":"type"},{"doc":"","ref":"CozyTelemetry.Poller.html","title":"CozyTelemetry.Poller","type":"module"},{"doc":"","ref":"CozyTelemetry.Poller.html#child_spec/1","title":"CozyTelemetry.Poller.child_spec/1","type":"function"},{"doc":"A behaviour for declaring reporters.","ref":"CozyTelemetry.Reporter.html","title":"CozyTelemetry.Reporter","type":"behaviour"},{"doc":"Checks required dependencies. When dependencies are missing, an exception should be raised.","ref":"CozyTelemetry.Reporter.html#c:check_deps/0","title":"CozyTelemetry.Reporter.check_deps/0","type":"callback"},{"doc":"","ref":"CozyTelemetry.Reporter.html#child_spec/1","title":"CozyTelemetry.Reporter.child_spec/1","type":"function"},{"doc":"Generates child specification for starting a reporter.","ref":"CozyTelemetry.Reporter.html#c:child_spec/1","title":"CozyTelemetry.Reporter.child_spec/1","type":"callback"},{"doc":"Prints consistent error messages of missing package for reporters.","ref":"CozyTelemetry.Reporter.html#print_missing_package/1","title":"CozyTelemetry.Reporter.print_missing_package/1","type":"function"},{"doc":"","ref":"CozyTelemetry.Reporter.html#t:child_spec/0","title":"CozyTelemetry.Reporter.child_spec/0","type":"type"},{"doc":"","ref":"CozyTelemetry.Reporter.html#t:init_arg/0","title":"CozyTelemetry.Reporter.init_arg/0","type":"type"},{"doc":"A wrapper of Elixir.Telemetry.Metrics.ConsoleReporter .","ref":"CozyTelemetry.Reporters.Console.html","title":"CozyTelemetry.Reporters.Console","type":"module"},{"doc":"A wrapper of Elixir.TelemetryMetricsPrometheus .","ref":"CozyTelemetry.Reporters.Prometheus.html","title":"CozyTelemetry.Reporters.Prometheus","type":"module"},{"doc":"A wrapper of Elixir.TelemetryMetricsStatsd .","ref":"CozyTelemetry.Reporters.Statsd.html","title":"CozyTelemetry.Reporters.Statsd","type":"module"},{"doc":"Provides a modular approach for using beam-telemetry packages.","ref":"readme.html","title":"CozyTelemetry","type":"extras"},{"doc":"Add cozy_telemetry to the list of dependencies in mix.exs : def deps do [ { :cozy_telemetry , version } ] end","ref":"readme.html#installation","title":"CozyTelemetry - Installation","type":"extras"},{"doc":"For more information, see the documentation .","ref":"readme.html#usage","title":"CozyTelemetry - Usage","type":"extras"},{"doc":"Apache License 2.0","ref":"readme.html#license","title":"CozyTelemetry - License","type":"extras"}]